# Size Manager Plus
An old Risk of Rain 2 mod brought back to modern times with a few extra additions!
This mod allows you to resize characters in varying ways using the heavily-customisable configuration file.
You can even have the size of characters change on the fly!
## Warning
While the mod __can__ be used in multiplayer, it is not designed with multiplayer in mind!
Bugs that occur exclusively within multiplayer will not be fixed unless if official multiplayer support is added.
If you find a bug in multiplayer - __test if it can happen in singleplayer__ before requesting support.
For best multiplayer results, everyone __should use the same configuration settings__.
## Features
- Configurable resizing for certain conditions.
- Not constrained to certain sizes; be as specific as you want to be. 75%? 133.333%? Up to you.
- Adjustable size cap, or even the option to remove it entirely.
- Safely stops anything from being smaller than 0.1%.
- Supports applying NPC size modifications to players that are on the monster team.
- Allows size to also affect the statistics of characters (e.g. more max life, more damage...).
- Resize on the fly; grow (or shrink) as you collect items and/or level up.
- Bigger eyes see further; the bigger you are, the larger your camera's field of view becomes.
## Installation
1. Install [BepInEx](https://thunderstore.io/package/bbepis/BepInExPack/) and [R2API](https://thunderstore.io/package/tristanmcpherson/R2API/) if you haven't already, for some reason.
2. Install this mod in __Steam/SteamApps/common/Risk Of Rain 2/BepInEx/plugins/__.
3. Run the game and see if it works!
## Contact
[Steam](https://steamcommunity.com/id/squishyghost) (Remember to leave a comment on my profile so I know why you're adding me!)
Discord : jen walter#5947 (Warning: you must be within the RoR2 modding Discord otherwise I'll think this is a random friend request!)
## Configuration
==Camera==
- __sizeCamera__ [Boolean] : true : If true, the camera will scale alongside the player's size.
- __fixCamera__ [Boolean] : true : If true, attempts to reposition the camera to be above the player's head.
- __fixCamera-Sensitivity-Height__ [Float] : 1.5 : How fast the camera scrolls downwards/upwards relative to player size.
- __fixCamera-Sensitivity-Width__ [Float] : 1.9 : How fast the camera zooms inwards/outwards relative to the player's size.
==Contextual Deactivation==
- __disableInBazaar__ [Boolean] : true : If true, characters are not resized while within the bazaar. Still performs stat calculations as a preview.
==Dynamic Size==
- __dynamicSize__ [Boolean] : false : If true, enables features which scale the size of entities on the fly.
- __continuousUpdate__ [Boolean] : false : If true, constantly updates size of every character. Can be intensive on framerate, but may iron out bugs.
- __sizeLeveling__ [Boolean] : false : If true, size is influenced by the level of the character.
- __sizeLevelingMinimum__ [Integer] : 1 : The character's level must be equal to or greater than this number first before size shifting.
- __sizeLevelingIncrement__ [Float] : 0.06 : % of size added per level above the minimum requirement.
- __sizeInventory__ [Boolean] : false : If true, the character's inventory items, excluding equipment and items of no tier, affect size.
- __sizeTier1__ [Float] : 0.01 : % of size added per white item carried.
- __sizeTier2__ [Float] : 0.03 : % of size added per green item carried.
- __sizeTier3__ [Float] : 0.09 : % of size added per red item carried.
- __sizeTierB__ [Float] : 0.05 : % of size added per yellow item carried.
- __sizeTierL__ [Float] : -0.05 : % of size added per blue item carried.
- __sizeTier1Scrap__ [Float] : 0.01 : % of size added per white scrap carried.
- __sizeTier2Scrap__ [Float] : 0.03 : % of size added per green scrap carried.
- __sizeTier3Scrap__ [Float] : 0.09 : % of size added per red scrap carried.
- __sizeTierBScrap__ [Float] : 0.05 : % of size added per yellow scrap carried.
- __sizePearl__ [Float] : 0.02 : % of size added per pearl carried.
- __sizeShinyPearl__ [Float] : 0.05 : % of size added per irradiant pearl carried.
- __sizeGlass__ [Float] : 0.5 : Total size of the character is multiplied by this value for every Shaped Glass they have.
- __sizeItemCount__ [Float] : 0 : % of size added per item of all tiers carried.
==Limitation==
- __sizeCapEnabled__ [Boolean] : true : If true, the size of any character cannot exceed the size cap value.
- __sizeCap__ [Float] : 10 : The size cap at which characters cannot get any larger.
- __sizeCapFormulas__ [Boolean] : true : If true, the size cap also applies to stat scaling.
==Size Modifiers==
- __baseSize__ [Float] : 1 : The base size for all characters, players and NPCs alike.
- __sizePlayer__ [Float] : 1.3 : Size multiplier for friendly players.
- __sizeAlly__ [Float] : 1.1 : Size multiplier for friendly NPCs.
- __sizeMonster__ [Float] : 1.3 : Size multiplier for hostile players & hostile NPCs.
- __sizeBoss__ [Float] : 1.15 : Size multiplier for boss hostiles.
- __sizeElite__ [Float] : 1.2 : Additional size multiplier for elite hostiles.
- __sizeChampion__ [Float] : 1.4 : Additional size multiplier for Teleporter hostiles.
- __sizeChampionBoss__ [Float] : 1.2 : Additional size multiplier for Teleporter boss hostiles.
==Statistic Modifiers==
- __healthScaling__ [Integer] : 1 : Scales max health alongside size. 0 - off / 1 - linear scaling / 2 - exponential scaling
- __damageScaling__ [Integer] : 1 : Scales damage alongside size. 0 - off / 1 - linear scaling / 2 - exponential scaling
- __armourScaling__ [Integer] : 0 : Scales armour alongside size. 0 - off / 1 - linear scaling / 2 - exponential scaling
- __speedScaling__ [Integer] : 0 : Scales movement speed alongside size. 0 - off / 1 - realistic (multiply) / 2 - inverse (divide)
- __jumpScaling__ [Integer] : 0 : Scales jump height alongside size. 0 - off / 1 - realistic (multiply) / 2 - inverse (divide)
- __hasteScaling__ [Integer] : 0 : Scales attack speed alongside size. 0 - off / 1 - realistic (divide) / 2 - inverse (multiply)
- __multiplierStrength__ [Float] : 1 : Strength of the multiplier used in linear scaling.
- __exponentStrength__ [Float] : 1.3 : Strength of the exponent used in exponential scaling.
=====
- _You must launch the game with this mod installed at least once to generate the configuration file._
## Credits
__Magnus__ : Assistance with error fixing, motivated me to learn as well!
__Ryan Pallesen__ : Original creator of this mod.
__Jarlyk__ : Assistance with v2.0.0.
__iDeathHD__ : Assistance with v2.0.0.
__mries92__ : Assistance with v2.0.1 (somewhat).
## Changelog
- __2.4.4__ : Split camera fix sensitivity option to two options, allowing adjustment of height and width of camera.
- __2.4.3__ : Fixed Shaped Glass breaking the player's stat scaling.
- __2.4.2__ : Added option to disable size-related stat calculations related with Shaped Glass. Added option to disable resize while in bazaar. Added camera fix sensitivity option.
- __2.4.1__ : Attempt to fix some issues by briefly delaying resize on spawn. Added constant update variable. Added unique dynamic size change via Shaped Glass.
- __2.4.0__ : Fixed Artifact Reliquary self-destructing. Added option to shift camera upwards with size.
- __2.0.3__ : Fixed buggy camera scaling. Fixed sizeCamera still scaling camera even if turned off. Fixed leveling (again).
- __2.0.2__ : Dud release.
- __2.0.1__ : Fixed incorrect size scaling with leveling, fixed error with monsters not increasing in size when both dynamic systems were active, raised default size cap to 10.
- __2.0.0__ : Added dynamic scaling, added camera scaling.
- __1.0.0__ : Initial release.